﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;
using System.IO;

namespace ConsoleCorrectness
{
    class Testing
    {
        int state = 1;
        public void TestSum()
        {
            double[] X = { 1, 3, 5, 7 };
            Simple sim = new Simple(X);
            double sum = sim.Sum1();
            Console.WriteLine("Sum1(1, 3, 5, 7) = {0} ", sum);
            sum = sim.Sum2();
            Console.WriteLine("Sum2(1, 3, 5, 7) = {0} ", sum);
            sum = sim.Sum3();
            Console.WriteLine("Sum3(1, 3, 5, 7) = {0} ", sum);
            sum = sim.Sum4();
            Console.WriteLine("Sum4(1, 3, 5, 7) = {0} ", sum);
        }
        public void TestDebugPrint()
        {
            DebugPrint.PrintEntry("Testing.TestDebugPrint");
            PubMethod();
            DebugPrint.PrintObject(state, "Testing.state");
            DebugPrint.PrintExit("Testing.TestDebugPrint");

        }
        void InMethod1()
        {
            DebugPrint.PrintEntry("InMethod1");
            // body
            DebugPrint.PrintExit("InMethod1");
        }
        void InMethod2()
        {
            DebugPrint.PrintEntry("InMethod2");
            // body
            DebugPrint.PrintExit("InMethod2");
        }
        public void PubMethod()
        {
            DebugPrint.PrintEntry("PubMethod");
            InMethod1();
            state++;
            InMethod2();
            DebugPrint.PrintExit("PubMethod");
        }
        public void TestOptima()
        {
            double x, y = 1;
            x = y - 2 * Math.Sin(y);
            FileStream f = new FileStream(
                "Debuginfo.txt", FileMode.Create, FileAccess.Write);
            TextWriterTraceListener writer1 = 
                new TextWriterTraceListener(f);
            TextWriterTraceListener writer2 = 
                new TextWriterTraceListener(System.Console.Out);
            Trace.Listeners.Add(writer1);
            Debug.Listeners.Add(writer2);
            Debug.WriteLine("Число слушателей:" + Debug.Listeners.Count);
            Debug.WriteLine("автоматический вывод из буфера:" + 
                Trace.AutoFlush);
            Trace.WriteLineIf(x < 0, "Trace: " + "x= " + 
                x.ToString() + " y = " + y);
            Debug.WriteLine("Debug: " + "x= " + x.ToString() + 
                " y = " + y);
            Trace.Flush();
            f.Close();
        }
        public void TestAssert()
        {
            Random rnd = new Random();
            Stream myFile = new FileStream("TestFile.txt", FileMode.Create, FileAccess.Write);
            TextWriterTraceListener myTextListener = new
                TextWriterTraceListener(myFile);
            int y = Debug.Listeners.Add(myTextListener);
            TextWriterTraceListener myWriter = new
                TextWriterTraceListener(System.Console.Out);
            Trace.Listeners.Add(myWriter);
            Trace.AutoFlush = true;
            Trace.WriteLine("автоматический вывод из буфера:" +
                Trace.AutoFlush);

            //Случайный выбор
            int u = rnd.Next(2, 12), v = rnd.Next(2, 12),
                w = rnd.Next(2, 12);
            //Спорное утверждение
            Trace.Assert(u + v + w <= 21, "Перебор: u + v + w > 21");

            Debug.WriteLine("u = " + u + " v = " + v + " w = " + w); 
            myWriter.WriteLine("Вывод только на консоль");
            Trace.Flush();
            //Вывод только в файл
            byte[] buf = { (byte)'B', (byte)'u', (byte)'f' };
            myFile.Write(buf, 0, 3);
            myFile.Close();
        }
        public void TestPattern()
        {
            Excepts ex1 = new Excepts();
            try
            {
                ex1.Pattern();
            }
            catch (Exception e)
            {
                Console.WriteLine("исключительная ситуация при вызове Pattern");
                Console.WriteLine(e.ToString());
                Excepts.PrintProperties(e);
            }
        }


    }
}
        